import java.awt.*;

public class DrawingBattleship extends DrawningShip {

    public DrawingBattleship(int speed, double weight, Color bodyColor, Color additionalColor,boolean tower,
                             boolean section, int width, int height, int blocksType, int blocksNumber) {
        super(speed, weight, bodyColor, width, height, blocksType, blocksNumber);
        if (entityShip != null)
            entityShip = new EntityBattleship(speed, weight, bodyColor, additionalColor, tower, section);
    }

      public void drawTransport(Graphics2D g2d){
          if (entityShip == null)
              return;

          super.drawTransport(g2d);
          g2d.setColor(((EntityBattleship)entityShip).AdditionalColor);
          BasicStroke pen = new BasicStroke(2);
          g2d.setStroke(pen);
          //орудийная башня
        if (((EntityBattleship)entityShip).Tower) {
            g2d.fillRect(startPosX + 108, startPosY + 28, 15, 15);
            g2d.drawRect(startPosX + 108, startPosY + 28, 15, 15);
           // добавить черный цвет пушке
            Color gunColor = Color.BLACK;
            g2d.setColor(gunColor);
            g2d.setStroke(pen);
            g2d.fillRect(startPosX + 123, startPosY + 32, 47, 6);
            g2d.drawRect(startPosX + 123, startPosY + 32, 55, 6);
        }
        //отсеки под ракеты
        if (((EntityBattleship)entityShip).Section) {
            g2d.fillRect(startPosX + 20, startPosY + 70, 40, 10);
            g2d.fillRect(startPosX + 75, startPosY + 70, 40, 10);
            g2d.setPaint(Color.BLACK);
            g2d.drawRect(startPosX + 20, startPosY + 70, 40, 10);
            g2d.drawRect(startPosX + 75, startPosY + 70, 40, 10);
        }
    }
}
