public class DrawningObjectShip implements IMoveableObject {
    private DrawningShip drawingShip = null;
    public DrawningObjectShip(DrawningShip _drawingShip)
    {
        drawingShip = _drawingShip;
    }
    public ObjectParameters GetObjectPosition(){
        if (drawingShip == null || drawingShip.getEntityShip() ==  null)
        {
            return null;
        }
        return new ObjectParameters(drawingShip.GetPosX(),
                drawingShip.GetPosY(), drawingShip.GetWidth(), drawingShip.GetHeight());
    }
    public int GetStep(){ return (int)drawingShip.getEntityShip().Step; }
    public boolean CheckCanMove(DirectionType direction) { return drawingShip.CanMove(direction);}
    public void MoveObject(DirectionType direction) { drawingShip.MoveTransport(direction); }

}
