import java.awt.*;
public class EntityShip {
    /// <summary>
    /// Скорость
    /// </summary>
    public int Speed;
    /// <summary>
    /// Вес
    /// </summary>
    public double Weight;
    /// <summary>
    /// Основной цвет
    /// </summary>
    public Color BodyColor;
    /// <summary>
    /// Шаг перемещения поезда
    /// </summary>
    public double Step;

    /// <summary>
    /// Инициализация полей объекта-класса Локомотива
    /// </summary>
    /// <param name="speed">Скорость</param>
    /// <param name="weight">Вес автомобиля</param>
    /// <param name="bodyColor">Основной цвет</param>
    public EntityShip(int speed, double weight, Color bodyColor)
    {
        Speed = speed;
        Weight = weight;
        BodyColor = bodyColor;
        Step = (double)Speed * 100 / Weight;
    }
}
