//import javax.imageio.ImageIO;
//import javax.swing.*;
//import java.awt.*;
//import java.awt.event.ActionEvent;
//import java.io.File;
//import java.io.IOException;
//import java.util.Random;
//
//public class FrameBattleship extends JFrame {
//    private DrawingBattleship drawingBattleship;
//    private DrawningShip drawningShip;
//    private AbstractStrategy abstractStrategy;
//    private JComboBox<String> comboBoxStrategy;
//    private JComponent pictureBox;
//
//    public FrameBattleship() throws IOException {
//        super("Линкор");
//        setSize(new Dimension(900, 500));
//        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
//        //components initialisation
//        pictureBox = new JComponent() {
//            public void paintComponent(Graphics graphics) {
//                super.paintComponent(graphics);
//                Graphics2D graphics2D = (Graphics2D) graphics;
//                if (drawingBattleship != null) drawingBattleship.drawTransport(graphics2D);
//                super.repaint();
//            }
//        };
//        pictureBox.setBounds(0, 0, getContentPane().getWidth(), getContentPane().getHeight());
//        comboBoxStrategy = new JComboBox<>(new String[]{"К центру", "К границе"});
//        JButton stepButton = new JButton("Шаг");
//        JButton createShipButton = new JButton("Создать корабль");
//        JButton createBattleshipButton = new JButton("Создать военный корабль");
//        JButton rightButton = new JButton(new ImageIcon(ImageIO.read(new File("C:\\RPP intellij\\LabWork_01\\images\\right-arrow.png"))));
//        rightButton.setPreferredSize(new Dimension(30, 30));
//        JButton leftButton = new JButton(new ImageIcon(ImageIO.read(new File("C:\\RPP intellij\\LabWork_01\\images\\left-arrow.png"))));
//        leftButton.setPreferredSize(new Dimension(30, 30));
//        JButton upButton = new JButton(new ImageIcon(ImageIO.read(new File("C:\\RPP intellij\\LabWork_01\\images\\upper-arrow.png"))));
//        upButton.setPreferredSize(new Dimension(30, 30));
//        JButton downButton = new JButton(new ImageIcon(ImageIO.read(new File("C:\\RPP intellij\\LabWork_01\\images\\down-arrow.png"))));
//        downButton.setPreferredSize(new Dimension(30, 30));
//        //ActionListeners and ActionCommand addition
//        createShipButton.addActionListener(e -> buttonCreateShipClick());
//        createBattleshipButton.addActionListener(e -> buttonCreateBattleshipClick());
//        stepButton.addActionListener(e -> buttonStepClick());
//        rightButton.setActionCommand("right");
//        rightButton.addActionListener(this::buttonMoveClick);
//        leftButton.setActionCommand("left");
//        leftButton.addActionListener(this::buttonMoveClick);
//        upButton.setActionCommand("up");
//        upButton.addActionListener(this::buttonMoveClick);
//        downButton.setActionCommand("down");
//        downButton.addActionListener(this::buttonMoveClick);
//        //panels and constraints initialisation
//        JPanel panelBattleship = new JPanel(new BorderLayout());
//        JPanel rightPanel = new JPanel(new BorderLayout());
//        JPanel leftPanel = new JPanel(new BorderLayout());
//        JPanel createPanel = new JPanel(new BorderLayout());
//        JPanel movementPanel = new JPanel(new GridBagLayout());
//        GridBagConstraints constraints = new GridBagConstraints();
//        constraints.insets.left = constraints.insets.top = constraints.insets.bottom = constraints.insets.right = 2;
//        //addition to createPanel
//        constraints.gridx = 0;
//        constraints.gridy = 0;
//        createPanel.add(createShipButton, BorderLayout.SOUTH);
//        constraints.gridx = 1;
//        constraints.gridy = 0;
//        createPanel.add(createBattleshipButton, constraints);
//        //addition to movementPanel
//        constraints.gridx = 2;
//        constraints.gridy = 1;
//        movementPanel.add(rightButton, constraints);
//        constraints.gridx = 0;
//        constraints.gridy = 1;
//        movementPanel.add(leftButton, constraints);
//        constraints.gridx = 1;
//        constraints.gridy = 0;
//        movementPanel.add(upButton, constraints);
//        constraints.gridx = 1;
//        constraints.gridy = 1;
//        movementPanel.add(downButton, constraints);
//        //addition to stepPanel
//        JPanel stepPanel = new JPanel(new GridBagLayout());
//        constraints.gridx = 0;
//        constraints.gridy = 0;
//        stepPanel.add(comboBoxStrategy, constraints);
//        constraints.gridx = 0;
//        constraints.gridy = 1;
//        stepPanel.add(stepButton, constraints);
//        //addition to frame
//        setLayout(new BorderLayout());
//        add(pictureBox);
//        rightPanel.add(movementPanel, BorderLayout.SOUTH);
//        rightPanel.add(stepPanel, BorderLayout.NORTH);
//        leftPanel.add(createPanel, BorderLayout.SOUTH);
//        panelBattleship.add(rightPanel, BorderLayout.EAST);
//        panelBattleship.add(leftPanel, BorderLayout.WEST);
//        add(panelBattleship, BorderLayout.CENTER);
//        setVisible(true);
//    }
//
//    private void buttonCreateShipClick() {
//        Random random = new Random();
//        pictureBox.setBounds(0,0,getContentPane().getWidth(),getContentPane().getHeight());
//        drawningShip = new DrawningShip(random.nextInt(200) + 100, random.nextInt(2000) + 1000, new Color(random.nextInt(256), random.nextInt(256), random.nextInt(256)),
//                pictureBox.getWidth(), pictureBox.getHeight(), random.nextInt(3),(random.nextInt(3)+1)*2);
//        drawingBattleship.SetPosition(random.nextInt(90) + 10, random.nextInt(90) + 10);
//        draw();
//    }
//    private void buttonCreateBattleshipClick() {
//        Random random = new Random();
//        pictureBox.setBounds(0,0,getContentPane().getWidth(),getContentPane().getHeight());
//        drawingBattleship = new DrawingBattleship(random.nextInt(200) + 100, random.nextInt(2000) + 1000, new Color(random.nextInt(256), random.nextInt(256), random.nextInt(256)),
//                new Color(random.nextInt(256), random.nextInt(256), random.nextInt(256)), random.nextBoolean(), random.nextBoolean(), pictureBox.getWidth(), pictureBox.getHeight(), random.nextInt(3),(random.nextInt(3)+1)*2);
//        drawingBattleship.SetPosition(random.nextInt(90) + 10, random.nextInt(90) + 10);
//        draw();
//    }
//
//    private void buttonStepClick(){
//        if (drawingBattleship == null) {
//            return;
//        }
//        if (comboBoxStrategy.isEnabled()) {
////            switch (comboBoxStrategy.getSelectedIndex()) {
////                case 0 -> abstractStrategy = new MoveToCenter();
////                case 1 -> abstractStrategy = new MoveToBorder();
////                default -> abstractStrategy = null;
////            }
//            if (abstractStrategy == null) {
//                return;
//            }
//            abstractStrategy.SetData(new DrawningObjectShip(drawingBattleship), pictureBox.getWidth(), pictureBox.getHeight());
//            comboBoxStrategy.setEnabled(false);
//        }
//        if (abstractStrategy == null) {
//            return;
//        }
//        abstractStrategy.MakeStep();
//        draw();
//        if (abstractStrategy.GetStatus() == Status.Finish)
//        {
//            comboBoxStrategy.setEnabled(true);
//            abstractStrategy = null;
//        }
//    }
//    private void buttonMoveClick(ActionEvent event) {
//        if (drawingBattleship == null || drawingBattleship.getEntityShip() == null)
//            return;
//        switch (event.getActionCommand()) {
//            case "left":
//                drawingBattleship.MoveTransport(DirectionType.LEFT);
//                break;
//            case "right":
//                drawingBattleship.MoveTransport(DirectionType.RIGHT);
//                break;
//            case "up":
//                drawingBattleship.MoveTransport(DirectionType.UP);
//                break;
//            case "down":
//                drawingBattleship.MoveTransport(DirectionType.DOWN);
//                break;
//            default:
//                break;
//        }
//        draw();
//    }
//
//    private void draw() {
//        if (drawingBattleship == null) {
//            return;
//        }
//        pictureBox.repaint();
//    }
//
//}




import javax.imageio.ImageIO;
import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.io.File;
import java.io.IOException;
import java.util.Random;

public class FrameBattleship extends JFrame {
    private DrawningShip drawningShip;
    private AbstractStrategy abstractStrategy;
    private JComboBox<String> comboBoxStrategy;
    private JComponent pictureBoxBattleship;
    public FrameBattleship() throws IOException {
        super("Линкор");
        setSize(new Dimension(900,500));
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        //components initialisation
        pictureBoxBattleship = new JComponent(){
            public void paintComponent(Graphics graphics){
                super.paintComponent(graphics);
                Graphics2D graphics2D = (Graphics2D) graphics;
                if (drawningShip != null) drawningShip.drawTransport(graphics2D);
                super.repaint();
            }
        };
        pictureBoxBattleship.setBounds( 0, 0, getContentPane().getWidth(), getContentPane().getHeight());
        comboBoxStrategy = new JComboBox<>(new String[]{"к центру", "к границе"});
        JButton stepButton = new JButton("Шаг");
        JButton createShipButton = new JButton("Создать корабль");
        JButton createBattleshipButton = new JButton("Создать военный корабль");
        JButton rightButton = new JButton(new ImageIcon(ImageIO.read(new File("C:\\RPP intellij\\LabWork_01\\images\\right-arrow.png"))));
        rightButton.setPreferredSize(new Dimension(30, 30));
        JButton leftButton = new JButton(new ImageIcon(ImageIO.read(new File("C:\\RPP intellij\\LabWork_01\\images\\left-arrow.png"))));
        leftButton.setPreferredSize(new Dimension(30, 30));
        JButton upButton = new JButton(new ImageIcon(ImageIO.read(new File("C:\\RPP intellij\\LabWork_01\\images\\upper-arrow.png"))));
        upButton.setPreferredSize(new Dimension(30, 30));
        JButton downButton = new JButton(new ImageIcon(ImageIO.read(new File("C:\\RPP intellij\\LabWork_01\\images\\down-arrow.png"))));
        downButton.setPreferredSize(new Dimension(30,30));
        //ActionListeners and ActionCommand addition
        createShipButton.addActionListener(e -> buttonCreateShipClick());
        createBattleshipButton.addActionListener(e -> buttonCreateBattleshipClick());
        stepButton.addActionListener(e -> buttonStepClick());
        rightButton.setActionCommand("right");
        rightButton.addActionListener(this::buttonMoveClick);
        leftButton.setActionCommand("left");
        leftButton.addActionListener(this::buttonMoveClick);
        upButton.setActionCommand("up");
        upButton.addActionListener(this::buttonMoveClick);
        downButton.setActionCommand("down");
        downButton.addActionListener(this::buttonMoveClick);
        //panels and constraints initialisation
        JPanel panelBattleship = new JPanel(new BorderLayout());
        JPanel rightPanel = new JPanel(new BorderLayout());
        JPanel leftPanel = new JPanel(new BorderLayout());
        JPanel createPanel = new JPanel(new GridBagLayout());
        JPanel movementPanel = new JPanel(new GridBagLayout());
        GridBagConstraints constraints = new GridBagConstraints();
        constraints.insets.left = constraints.insets.top = constraints.insets.bottom = constraints.insets.right = 2;
        //addition to createPanel
        constraints.gridx = 0;
        constraints.gridy = 0;
        createPanel.add(createShipButton, constraints);
        constraints.gridx = 1;
        constraints.gridy = 0;
        createPanel.add(createBattleshipButton, constraints);
        //addition to movementPanel
        constraints.gridx = 2;
        constraints.gridy = 1;
        movementPanel.add(rightButton, constraints);
        constraints.gridx = 0;
        constraints.gridy = 1;
        movementPanel.add(leftButton, constraints);
        constraints.gridx = 1;
        constraints.gridy = 0;
        movementPanel.add(upButton, constraints);
        constraints.gridx = 1;
        constraints.gridy = 1;
        movementPanel.add(downButton, constraints);
        //addition to stepPanel
        JPanel stepPanel = new JPanel(new GridBagLayout());
        constraints.gridx = 0;
        constraints.gridy = 0;
        stepPanel.add(comboBoxStrategy, constraints);
        constraints.gridx = 0;
        constraints.gridy = 1;
        stepPanel.add(stepButton, constraints);
        //addition to frame
        setLayout(new BorderLayout());
        add(pictureBoxBattleship);
        rightPanel.add(movementPanel, BorderLayout.SOUTH);
        rightPanel.add(stepPanel, BorderLayout.NORTH);
        leftPanel.add(createPanel, BorderLayout.SOUTH);
        panelBattleship.add(rightPanel, BorderLayout.EAST);
        panelBattleship.add(leftPanel, BorderLayout.WEST);
        add(panelBattleship,BorderLayout.CENTER);
        setVisible(true);
    }
    private void buttonCreateBattleshipClick() {
        Random random = new Random();
        pictureBoxBattleship.setBounds(0,0,getContentPane().getWidth(),getContentPane().getHeight());
        drawningShip = new DrawingBattleship(random.nextInt(200) + 100, random.nextInt(2000) + 1000, new Color(random.nextInt(256), random.nextInt(256), random.nextInt(256)),
                new Color(random.nextInt(256), random.nextInt(256), random.nextInt(256)), random.nextBoolean(), random.nextBoolean(), pictureBoxBattleship.getWidth(), pictureBoxBattleship.getHeight(), random.nextInt(3),(random.nextInt(3)+1)*2);
        drawningShip.SetPosition(random.nextInt(90) + 10, random.nextInt(90) + 10);
        draw();
    }
    private void buttonCreateShipClick(){
        Random random = new Random();
        pictureBoxBattleship.setBounds(0,0,getContentPane().getWidth(),getContentPane().getHeight());
        drawningShip = new DrawningShip(random.nextInt(200) + 100, random.nextInt(2000) + 1000, new Color(random.nextInt(256), random.nextInt(256), random.nextInt(256)),
                pictureBoxBattleship.getWidth(), pictureBoxBattleship.getHeight(), random.nextInt(3),(random.nextInt(3)+1)*2);
        drawningShip.SetPosition(random.nextInt(90) + 10, random.nextInt(90) + 10);
        draw();
    }
    private void buttonStepClick(){
        if (drawningShip == null) {
            return;
        }
        if (comboBoxStrategy.isEnabled()) {
            switch (comboBoxStrategy.getSelectedIndex())
                        {
                            case 0:
                                abstractStrategy = new MoveToCenter();
                                break;
                            case 1:
                                abstractStrategy = new MoveToBorder();
                                break;
                            default:
                                abstractStrategy = null;
                                break;
                        };
            if (abstractStrategy == null) {
                return;
            }
            abstractStrategy.SetData(new DrawningObjectShip(drawningShip), pictureBoxBattleship.getWidth(), pictureBoxBattleship.getHeight());
            comboBoxStrategy.setEnabled(false);
        }
        if (abstractStrategy == null) {
            return;
        }
        abstractStrategy.MakeStep();
        draw();
        if (abstractStrategy.GetStatus() == Status.Finish)
        {
            comboBoxStrategy.setEnabled(true);
            abstractStrategy = null;
        }
    }

    private void buttonMoveClick(ActionEvent event) {
        if (drawningShip == null || drawningShip.getEntityShip() == null)
            return;
        switch (event.getActionCommand()) {
            case "left":
                drawningShip.MoveTransport(DirectionType.LEFT);
                break;
            case "right":
                drawningShip.MoveTransport(DirectionType.RIGHT);
                break;
            case "up":
                drawningShip.MoveTransport(DirectionType.UP);
                break;
            case "down":
                drawningShip.MoveTransport(DirectionType.DOWN);
                break;
            default:
                break;
        }
        draw();
    }
    private void draw() {
        if (drawningShip == null)
        {
            return;
        }
        pictureBoxBattleship.repaint();
    }
}