public class MoveToBorder extends AbstractStrategy {

    @Override
    protected boolean IsTargetDestinaion() {
        ObjectParameters objParams = getObjectParameters();
        if (objParams == null) {
            return false;
        }
        return objParams.RightBorder() <= getFieldWidth() &&
                objParams.RightBorder() + GetStep() >= getFieldWidth() &&
                objParams.DownBorder() <= getFieldHeight() &&
                objParams.DownBorder() + GetStep() >= getFieldHeight();
    }
    @Override
    protected void MoveToTarget() {
        ObjectParameters objParams = getObjectParameters();
        if (objParams == null) {
            return;
        }
        double diffX = objParams.RightBorder() - getFieldWidth();
        if (Math.abs(diffX) > GetStep()) {
            if (diffX > 0) {
                MoveLeft();
            } else {
                MoveRight();
            }
        }
        double diffY = objParams.DownBorder() - getFieldHeight();
        if (Math.abs(diffY) > GetStep()) {
            if (diffY > 0) {
                MoveUp();
            } else {
                MoveDown();
            }
        }
    }
}
