public class ObjectParameters {
    private final int POS_X;
    private final int POS_Y;
    private final int WIDTH;
    private final int HEIGHT;
    public int LeftBorder() {return POS_X;}
    public int TopBorder() {return POS_Y;}
    public int RightBorder() {return POS_X + WIDTH;}
    public int DownBorder() {return POS_Y + HEIGHT;}
    public int ObjectMiddleHorizontal() {return POS_X + this.WIDTH / 2;}
    public int ObjectMiddleVertical() {return POS_Y + this.HEIGHT / 2;}
    public ObjectParameters(int x, int y, int width, int height) {
        POS_X = x;
        POS_Y = y;
        WIDTH = width;
        HEIGHT = height;
    }
}
